package wargame;

import wargame.gui.Tile;
import wargame.gui.TileLayout;
import wargame.gui.hex.HexLayout;
import wargame.gui.hex.HexTile;
import wargame.gui.square.SquareLayout;
import wargame.gui.square.SquareTile;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.*;
import java.awt.Color;


import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.image.BufferedImage;
import java.io.IOException;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import javax.swing.filechooser.*;
import java.io.File;


/**
 * @author Noah Chatelain
 * @author Thierry Xu
 * @author Leo Heumel
 */

public abstract class Carre {

    public static void listFilesForFolder(final File folder, int styleOfMap, JMenu submenuCarre) {
        for (final File fileEntry : folder.listFiles()) {
            if (fileEntry.isDirectory()) {
                listFilesForFolder(fileEntry, styleOfMap, submenuCarre);
            } else {
                if (fileEntry.getName().equals(".DS_Store") == false)
                {
                    JMenuItem item;
                    item = new JMenuItem(new AbstractAction(fileEntry.getName().substring(0, fileEntry.getName().length() - 4)) {
                        public void actionPerformed(ActionEvent e) {
                            String command = "java wargame/Carre " + fileEntry.getName() + " " + styleOfMap;
                            try {
                                Process proc = Runtime.getRuntime().exec(command);
                                System.exit(-1);
                            }
                            catch(IOException event) {
                                event.printStackTrace();
                            }
                        }
                    });
                    submenuCarre.add(item);
                }
            }
        }
    }

    public static void main(String[] args) {
        int numberMap = 1;
        String[][] tab;
        Map map = new Map();
        String title = "map1.map";
        try {
            map.readFile("wargame/maps/" + args[0]);
            title = args[0];
        } catch (ArrayIndexOutOfBoundsException e) {
            map.readFile("wargame/maps/Map1.map");
        }
        tab = map.tabMap;
    
        PlayerRound playerRound = new PlayerRound();
        final int width = map.width;
        final int height = map.height;

        int interStyleMap;
        try {
            interStyleMap = Integer.parseInt(args[1]);
        } catch (ArrayIndexOutOfBoundsException e) {
            interStyleMap = 1;
        }
        
        TileLayout squareLayout;
        JPanel squarePanel;
        if (interStyleMap == 1) {
            squareLayout = new SquareLayout(height, width);
            squarePanel = new JPanel(squareLayout);
            squarePanel.setPreferredSize(squareLayout.getPreferredDimension(800));
        } else {
            squareLayout = new HexLayout(height, width);
            squarePanel = new JPanel(squareLayout);
            squarePanel.setPreferredSize(squareLayout.getPreferredDimension(800));
        }

        BufferedImage grass = null;
        BufferedImage water = null;
        BufferedImage ground = null;
        BufferedImage sand = null;
        BufferedImage ice = null;


        //Create TextField Hello Word
        JTextField textField = new JTextField();
        
        textField.setHorizontalAlignment(JTextField.CENTER);
        textField.setText("La partie commence avec " + playerRound.getPlayerName1() + ", GO ! Armée de " + playerRound.getNumberArmyDeployed());
        textField.setForeground(Color.red);
        textField.setEditable(false);
        

        JTextField textFieldRed = new JTextField();
        
        textFieldRed.setHorizontalAlignment(JTextField.CENTER);
        textFieldRed.setText(playerRound.getPlayerName1() + " | " + playerRound.getTotalRed());
        textFieldRed.setForeground(Color.red);
        textFieldRed.setEditable(false);

        JTextField textFieldBlue = new JTextField();
        
        textFieldBlue.setHorizontalAlignment(JTextField.CENTER);
        textFieldBlue.setText(playerRound.getPlayerName2() + " | " + playerRound.getTotalBlue());
        textFieldBlue.setForeground(Color.blue);
        textFieldBlue.setEditable(false);


        JMenuBar mb = new JMenuBar();
        JMenu menu, submenuMap, submenuCarre, submenuHex;  
        JMenuItem restartPlay, closeMenu, changeNamePlayers, i3, i4, i5, i6, openMap;  
        menu = new JMenu("Menu");  
        submenuMap = new JMenu("Changer de Map");
        final int nM = numberMap;
        //MENU
        restartPlay = new JMenuItem(new AbstractAction("Recommencer") {
            public void actionPerformed(ActionEvent e) {
                String command = "java wargame/Carre " + args[0];
                try {
                    Process proc = Runtime.getRuntime().exec(command);
                    System.exit(-1);
                } catch(IOException event) {
                    event.printStackTrace();
                }
                //TODO: Refresh le contentPane a la place
        }
        });
        closeMenu = new JMenuItem(new AbstractAction("Fermer") {
            public void actionPerformed(ActionEvent e) {
                System.exit(-1);
            }
        });
        changeNamePlayers = new JMenuItem(new AbstractAction("Changer le nom des joueurs") {
            public void actionPerformed(ActionEvent e) {
                JFrame f = new JFrame("Changer le nom des joueurs");
                f.setLocationRelativeTo(null);
                JPanel contentPane2 = new JPanel();
                contentPane2.setLayout(new BoxLayout(contentPane2, BoxLayout.Y_AXIS));
                f.setContentPane(contentPane2);
                JLabel label1 = new JLabel("Nom joueur n°1");
                JTextField textfield1 = new JTextField(playerRound.getPlayerName1(), 20);
                JLabel label2 = new JLabel("Nom joueur n°2");
                JTextField textfield2 = new JTextField(playerRound.getPlayerName2(), 20);
                JButton buttonAddPlayer;
                buttonAddPlayer = new JButton(new AbstractAction("Continuer la partie") {
                    public void actionPerformed(ActionEvent e) {
                        playerRound.setPlayerName1(textfield1.getText());
                        textFieldRed.setText(playerRound.getPlayerName1() + " | " + playerRound.getTotalRed());
                        playerRound.setPlayerName2(textfield2.getText());
                        textFieldBlue.setText(playerRound.getPlayerName2() + " | " + playerRound.getTotalBlue());
                        f.setVisible(false);
                    }
                });
                contentPane2.add(label1);
                contentPane2.add(textfield1);
                contentPane2.add(label2);
                contentPane2.add(textfield2);
                contentPane2.add(buttonAddPlayer);
                f.pack();
                f.setVisible(true);
            }
        });
        openMap = new JMenuItem(new AbstractAction("Ouvrir ma propre carte") {
            public void actionPerformed(ActionEvent e) {
                JFileChooser chooser = new JFileChooser("./wargame/maps/");
                FileNameExtensionFilter filter = new FileNameExtensionFilter("Only map format", "map");
                chooser.setFileFilter(filter);
                int returnVal = chooser.showOpenDialog(null);
                if(returnVal == JFileChooser.APPROVE_OPTION) {
                    //System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());
                    String command = "java wargame/Carre " + chooser.getSelectedFile().getName();
                    try {
                        Process proc = Runtime.getRuntime().exec(command);
                        System.exit(-1);
                    }
                    catch(IOException event) {
                        event.printStackTrace();
                    }
                }
            }
        });
        //SUB MENU

        submenuCarre = new JMenu("Carre");
        submenuHex = new JMenu("Hexagonal");
        
        final File folder = new File("./wargame/maps/");
        listFilesForFolder(folder, 1, submenuCarre);
        listFilesForFolder(folder, 2, submenuHex);

        menu.add(changeNamePlayers);
        menu.add(restartPlay); 
        menu.add(closeMenu);
        menu.add(openMap);
        submenuMap.add(submenuCarre);
        submenuMap.add(submenuHex);
        menu.add(submenuMap);
        mb.add(menu);


        try {
            grass = ImageIO.read(Thread.currentThread().getContextClassLoader().getResource("assets/grass.png"));
            water = ImageIO.read(Thread.currentThread().getContextClassLoader().getResource("assets/water.jpg"));
            ground = ImageIO.read(Thread.currentThread().getContextClassLoader().getResource("assets/ground.png"));
            sand = ImageIO.read(Thread.currentThread().getContextClassLoader().getResource("assets/sand.png"));
            ice = ImageIO.read(Thread.currentThread().getContextClassLoader().getResource("assets/ice.png"));
        } catch (IOException e) {
            System.out.println("ERROR: file not found");

        } catch (NullPointerException e) {
            System.err.println("ERROR: an unexpected error occurred");
        }

        if (grass == null || water == null || ground == null || sand == null || ice == null) {
            // si on n'a pas réussi à charger l'image, on quitte le programme
            System.exit(-1);
        }
        

        for (int row = 0 ; row < height ; row++) {
            for (int column = 0 ; column < width ; column++) {

                    final int r = row;
                    final int c = column;

                    final int styleMap = interStyleMap;

                    Tile squareTile;
                    if (tab[row][column].equals("0")) {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", water);
                        } else {
                            squareTile = new HexTile("", water);
                        }
                    } else if (tab[row][column].equals("1")) {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", grass);
                        } else {
                            squareTile = new HexTile("", grass);
                        }
                    } else if (tab[row][column].equals("2")) {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", ground);
                        } else {
                            squareTile = new HexTile("", ground);
                        }
                    } else if (tab[row][column].equals("3")) {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", sand);
                        } else {
                            squareTile = new HexTile("", sand);
                        }
                    } else if (tab[row][column].equals("4")) {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", ice);
                        } else {
                            squareTile = new HexTile("", ice);
                        }
                    }
                    else {
                        if (styleMap == 1) {
                            squareTile = new SquareTile("", grass);
                        } else {
                            squareTile = new HexTile("", grass);
                        }
                    }

                    squareTile.field.set(tab[row][column]);


                    squareTile.addMouseListener(new MouseAdapter() {

                        public void mouseClicked(MouseEvent e) {
                            if (map.get(r, c).army.getSizeArmy() == 0 && map.get(r, c).field.get().equals("0") != true) {
                                    
                                squareTile.army.setSizeArmy(playerRound.getNumberArmyDeployed());
                                squareTile.setTextContent("" + squareTile.army.getSizeArmy());

                                playerRound.setNumberArmyDeployed();

                                if (playerRound.getPlayerRound() == 1) {
                                    textField.setText(playerRound.getPlayerName2() + " : Armée de " + playerRound.getNumberArmyDeployed());
                                    textField.setForeground(Color.blue);
                                    squareTile.player.setNumberPlayer(1);
                                    squareTile.setTextBackgroundColor(255, 0, 0);
                                    playerRound.setPlayerRound(2);
                                } else {
                                    textField.setText(playerRound.getPlayerName1() + " : Armée de " + playerRound.getNumberArmyDeployed());
                                    textField.setForeground(Color.red);
                                    squareTile.player.setNumberPlayer(2);
                                    squareTile.setTextBackgroundColor(0, 0, 255);
                                    playerRound.setPlayerRound(1);
                                }

                                try {
                                    if (map.get(r + 1, c).player.getNumberPlayer() != map.get(r, c).player.getNumberPlayer()) {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r + 1, c).army.getSizeArmy() && map.get(r + 1, c).getTextContent() != "")
                                        {
                                            map.get(r + 1, c).player.setNumberPlayer(map.get(r, c).player.getNumberPlayer());
                                            if (map.get(r + 1, c).player.getNumberPlayer() != 1) {
                                                map.get(r + 1, c).setTextBackgroundColor(0, 0, 255);
                                            } else {
                                                map.get(r + 1, c).setTextBackgroundColor(255, 0, 0);
                                            }
                                        }
                                    }
                                    else {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r + 1, c).army.getSizeArmy() && map.get(r + 1, c).getTextContent() != "")
                                        {
                                            map.get(r + 1, c).army.setSizeArmy(map.get(r + 1, c).army.getSizeArmy() + 1);
                                            map.get(r + 1, c).setTextContent("" + map.get(r + 1, c).army.getSizeArmy());
                                        }
                                    }
                                } catch(NullPointerException e1) {

                                } catch(ArrayIndexOutOfBoundsException e2) {

                                }

                                try {
                                    if (map.get(r - 1, c).player.getNumberPlayer() != map.get(r, c).player.getNumberPlayer()) {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r - 1, c).army.getSizeArmy() && map.get(r - 1, c).getTextContent() != "")
                                        {
                                            map.get(r - 1, c).player.setNumberPlayer(map.get(r, c).player.getNumberPlayer());
                                            if (map.get(r - 1, c).player.getNumberPlayer() != 1) {
                                                map.get(r - 1, c).setTextBackgroundColor(0, 0, 255);
                                            } else {
                                                map.get(r - 1, c).setTextBackgroundColor(255, 0, 0);
                                            }
                                        }
                                    }
                                    else {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r - 1, c).army.getSizeArmy() && map.get(r - 1, c).getTextContent() != "")
                                        {
                                            map.get(r - 1, c).army.setSizeArmy(map.get(r - 1, c).army.getSizeArmy() + 1);
                                            map.get(r - 1, c).setTextContent("" + map.get(r - 1, c).army.getSizeArmy());
                                        }
                                    }
                                } catch(NullPointerException e1) {

                                } catch(ArrayIndexOutOfBoundsException e2) {

                                }


                                try {
                                    if (map.get(r, c + 1).player.getNumberPlayer() != map.get(r, c).player.getNumberPlayer()) {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r, c + 1).army.getSizeArmy() && map.get(r, c + 1).getTextContent() != "")
                                        {
                                            map.get(r, c + 1).player.setNumberPlayer(map.get(r, c).player.getNumberPlayer());
                                            if (map.get(r, c + 1).player.getNumberPlayer() != 1) {
                                                map.get(r, c + 1).setTextBackgroundColor(0, 0, 255);
                                                
                                            } else {
                                                map.get(r, c + 1).setTextBackgroundColor(255, 0, 0);
                                            }
                                        }
                                    }
                                    else {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r, c + 1).army.getSizeArmy() && map.get(r, c + 1).getTextContent() != "")
                                        {
                                            map.get(r, c + 1).army.setSizeArmy(map.get(r, c + 1).army.getSizeArmy() + 1);
                                            map.get(r, c + 1).setTextContent("" + map.get(r, c + 1).army.getSizeArmy());
                                        }
                                    }
                                } catch(NullPointerException e1) {

                                } catch(ArrayIndexOutOfBoundsException e2) {

                                }

                                try {
                                    if (map.get(r, c - 1).player.getNumberPlayer() != map.get(r, c).player.getNumberPlayer()) {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r, c - 1).army.getSizeArmy() && map.get(r, c - 1).getTextContent() != "")
                                        {
                                            map.get(r, c - 1).player.setNumberPlayer(map.get(r, c).player.getNumberPlayer());
                                            if (map.get(r, c - 1).player.getNumberPlayer() != 1) {
                                                map.get(r, c - 1).setTextBackgroundColor(0, 0, 255);
                                            } else {
                                                map.get(r, c - 1).setTextBackgroundColor(255, 0, 0);
                                            }
                                        }
                                    }
                                    else {
                                        if (map.get(r, c).army.getSizeArmy() > map.get(r, c - 1).army.getSizeArmy() && map.get(r, c - 1).getTextContent() != "")
                                        {
                                            map.get(r, c - 1).army.setSizeArmy(map.get(r, c - 1).army.getSizeArmy() + 1);
                                            map.get(r, c - 1).setTextContent("" + map.get(r, c - 1).army.getSizeArmy());
                                        }
                                    }
                                } catch(NullPointerException e1) {

                                } catch(ArrayIndexOutOfBoundsException e2) {

                                }

                                int totalRed = 0;
                                int totalBlue = 0;
                                for (int i = 0; i < height; i++) {
                                    for (int j = 0; j < width; j++) {
                                        if (map.get(i, j).player.getNumberPlayer() == 1) {
                                            totalRed += (int)map.get(i, j).army.getSizeArmy();
                                        } else {
                                            totalBlue += (int)map.get(i, j).army.getSizeArmy();
                                        }
                                    }
                                }
                                playerRound.setTotalRed(totalRed);
                                playerRound.setTotalBlue(totalBlue);

                                textFieldRed.setText(playerRound.getPlayerName1() + " | " + playerRound.getTotalRed());
                                textFieldBlue.setText(playerRound.getPlayerName2() + " | " + playerRound.getTotalBlue());

                            }

                        }
                    });

                    //System.out.println(map.get(3, 1));
                    map.cells[row][column] = squareTile;
                    squarePanel.add(squareTile);

            }
        }


        JPanel contentPane = new JPanel();
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));

        JPanel contentTextField = new JPanel();
        contentTextField.setLayout(new BoxLayout(contentTextField, BoxLayout.X_AXIS));
        

        JFrame frame = new JFrame("Wargame (" + title + ")");
        frame.setContentPane(contentPane);
        frame.setLocationRelativeTo(null);

        frame.setJMenuBar(mb);

        contentPane.add(squarePanel);
        contentTextField.add(textFieldRed);
        contentTextField.add(textField);
        contentTextField.add(textFieldBlue);

        contentPane.add(contentTextField);


        // on demande à notre JFrame de se dimensionner automatiquement en fonction de la taille de son contenu
        frame.pack();

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);



/*
        JFrame f = new JFrame("Text Field Examples");
        JPanel contentPane2 = new JPanel();
        contentPane2.setLayout(new BoxLayout(contentPane2, BoxLayout.Y_AXIS));
        f.setContentPane(contentPane2);
        JLabel label1 = new JLabel("Nom joueur n°1");
        JTextField textfield1 = new JTextField("Text field 1", 20);
        JLabel label2 = new JLabel("Nom joueur n°2");
        JTextField textfield2 = new JTextField("Text field 2", 20);
        JButton buttonAddPlayer;
        buttonAddPlayer = new JButton(new AbstractAction("Jouer !") {
            public void actionPerformed(ActionEvent e) {
                playerRound.setPlayerName1(textfield1.getText());
                textFieldRed.setText(playerRound.getPlayerName1() + " | " + playerRound.getTotalRed());
                playerRound.setPlayerName2(textfield2.getText());
                textFieldBlue.setText(playerRound.getPlayerName2() + " | " + playerRound.getTotalRed());
                f.setVisible(false);
            }
        });
        contentPane2.add(label1);
        contentPane2.add(textfield1);
        contentPane2.add(label2);
        contentPane2.add(textfield2);
        contentPane2.add(buttonAddPlayer);
        f.pack();
        f.setVisible(true);
*/

    }
}